/**
 * $Id: ReadWrite.java,v 1.6 2001/11/12 12:57:34 jerome Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/** define the Process parameter structures
*/

/**
Author  : Laurent Tardif
Date    : 05 01 2001

*/

package fr.fluxmedia.transmorpher.Files ;

import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;


/* **********************************************************************

Class ReadWrite

*********************************************************************** */


public  class ReadWrite implements Constants{
  
    FileWriter vFileW = null;
    FileReader vFileR = null;
    String vFileName = null ;
    int vMode = 0 ;
    
    public ReadWrite(String pName, int pMode) {
      vFileName = pName ;
      vMode = pMode ;
      try {
         if (pMode == WRITE ) {
          if (TRACE_MACHINE) System.err.println("[Save] " + pName );
          vFileW = new FileWriter( pName ); 
         } else { 
          if (TRACE_MACHINE) System.err.println("[Load] " + pName );
          vFileR = new FileReader (pName);
         }
          
      } catch (java.io.IOException pE) {
        if (pMode == WRITE ) {
          System.err.println("[Save] " + pE );
        } else {
          System.err.println("[Load] " + pE );
        }
        
      }
        
    }
    
    public String getName() {
      return vFileName ;
    }

    public void Write(String pString) {
      try {
        //System.err.print("[" +vFileName +"] : " +pString);
        vFileW.write(pString);
      } catch (java.io.IOException pE) {
        System.err.println("[Save] " + pE );
      }
        
    }

   public void Write(int Decalage,String pString) {
      String vParam ="";
      for (int i=0;i<Decalage;i++) {
        vParam+=" ";
      }
      Write(vParam+pString);       
    }

   public void Writeln(int Decalage,String pString) {
      String vParam ="";
      for (int i=0;i<Decalage;i++) {
        vParam+=" ";
      }
      Writeln(vParam+pString);       
    }
    
    public void Writeln(String pString) {
      try {
        //System.err.println("[" +vFileName +"] : " +pString+"\n");
        vFileW.write(pString +"\n");
      } catch (java.io.IOException pE) {
        System.err.println("[Save] " + pE );
      }
        
    }

    public void Writeln() {
      try {
        vFileW.write("\n");
      } catch (java.io.IOException pE) {
        System.err.println("[Save] " + pE );
      }
    }

    public char [] Read() {
        char[] chaine = null ;
      try {
        
        int Taillefichier = (int) (new File(vFileName).length());
        chaine = new char[Taillefichier];
        int longueur = vFileR.read(chaine);
         if (TRACE_MACHINE) System.err.println("long= " + longueur);
     
      } catch (java.io.IOException pE) {
        System.err.println("[Load] " + pE );
      }
      return chaine ;  
    }
    
    

    public void Close() {
      try {  
        if (vMode == READ ) vFileR.close();   
        else vFileW.close();   

      } catch (java.io.IOException pE) {
        System.err.println("[Save] " + pE );
      }
      
    }
         
  }
