/**
 * $Id: Iterator.java,v 1.1 2001/10/11 13:19:15 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph iterator implementation
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;

import java.util.Enumeration;

import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Files.ReadWrite;


public class Iterator {

  String name = null;
  Parameters parameters = null;
  String type = null;
  Repeat repeat = null;

  public Iterator (String n, String t, Repeat r) {
      parameters = new Parameters();
    name = n;
    type = t;
    repeat = r;
  }

  /** Prints the XML expression of the call.
    * This is a default printer that can be overloaded
    */
    public void generateXML() {
      System.out.println("        <iterate name=\""+name+"\" type=\""+type+"\"");
      if ( parameters.isEmpty() ){
	  System.out.println("/>");
      } else {
	  System.out.println(">");
	  parameters.generateXMLCalls();
	  System.out.println("        </iterate>");
      }
    }
    
  public String getName(){
    return name;
  }
  
  public Repeat getRepeat(){
    return repeat;
  }
  
  public void setType(String t){
    type = t;
  }

  public String getType(){
    return type;
  }
  
  public void setParameters(Parameters param){
    parameters = param;
  }

  public Parameters getParameters(){
    return parameters;
  }
  
} //end iterator impl
