/**
 * $Id: PortList.java,v 1.7 2001/12/20 12:13:34 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph list of ports/channels
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;

import java.util.Vector;

import fr.fluxmedia.transmorpher.Files.ReadWrite;

public class PortList {

  Vector ports = null;

  PortList( int i ){
    ports = new Vector(i);
  }

  public int length(){
    return ports.size();
  }
  
  public void setPort(int i, Port p){
    ports.add(i,(Object)p);
  }
    
  public Port getPort(int i){
    return (Port)ports.get(i);
  }

  public void removePort( Port p ){
    for ( int i=0; i != ports.size() ; i++){
	if (ports.get(i) == p) {
	    ports.add(i,null);
	    i = ports.size() ;
	} // end if
     } //end for
  }

  /** NOT YET IMPLEMENTED **/
  public boolean checkPorts(){
    return true;
  }

  public String[] getNames() {
   String[] vAns = new String[length()];
   for (int i=0; i < length(); i++) {
    vAns[i]= ((Port)ports.get(i)).getName();
   } //end for
   return vAns ;
  }
 
  public final String[] toStringList() {
      int size = length() ;
      String[] vPort = new String[size] ;
      for (int i=0; i<size; i++) { vPort[i]= getPort(i).getName(); } //end for
      return vPort ;
  } //end proc

  /** Prints the XML expression of the call
   NOTE that getChannel().getName() would be cleaner */
  public void generateXML(){
    if ( ports.size() != 0 ) System.out.print(((Port)ports.get(0)).getName());
    for ( int i=1; i != ports.size() ; i++){
      System.out.print(" "+((Port)(ports.get(i))).getName());
    } //end for
  }

  /** Prints the Java code for the execution of the call */
  public void generateJavaCode(ReadWrite file){};
}

