/**
 * $Id: Transformation.java,v 1.8 2001/12/20 12:13:34 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph call node interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;

import fr.fluxmedia.transmorpher.Utils.LinearIndexedStruct;
import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Utils.StringParameters;
import fr.fluxmedia.transmorpher.Files.ReadWrite ;

public interface Transformation {

    /** Prints the XML expression of the call */
    public void generateXML();

    /** Prints the Java code for the execution of the call */
    public void generateJavaCode(ReadWrite file, LinearIndexedStruct externs);

    public String getName();
    public void setName(String name);
    public String getType();
    public void setType(String type);
    public void setParameters(Parameters param);
    public Parameters getParameters();
    public StringParameters getAttributes();
    public Transmorpher getTransmorpher();
    public PortList inPorts();
    public PortList outPorts();
    public void retroNull(PortList out, PortList in);
    
}
