/**
 * $Id: ContentHandler_Commands.java,v 1.2 2001/06/12 15:50:30 gchomat Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * This interface defines a set of usefull constant for Content handler
 * @author Laurent Tardif (laurent.tardif@inrialpes.fr)
 * @since jdk 1.2 / SAX 2.0
 */


package fr.fluxmedia.transmorpher.TProcessFactory ;

public interface ContentHandler_Commands {

  /** For the START_ELEMENT command*/
  static final int START_ELEMENT          = 0 ;

  /** For the END_ELEMENT command*/
  static final int END_ELEMENT            = 1 ;
  
  /** For the START_DOCUMENT command*/
  static final int START_DOCUMENT         = 2 ;

  /** For the END_DOCUMENT command*/
  static final int END_DOCUMENT           = 3 ;

  /** For the SET_DOCUMENT_LOCATOR command*/
  static final int SET_DOCUMENT_LOCATOR   = 4 ;

  /** For the SKIPPED_ENTITY command*/
  static final int SKIPPED_ENTITY         = 5 ;

  /** For the IGNORABLE_WHITESPACE command*/
  static final int IGNORABLE_WHITESPACE   = 6 ;

  /** For the PROCESSING_INSTRUCTION command*/
  static final int PROCESSING_INSTRUCTION = 7 ;

  /** For the CHARACTERS command*/
  static final int CHARACTERS             = 8 ;

  /** For the START_PREFIX_MAPPING command*/
  static final int START_PREFIX_MAPPING   = 9 ;

  /** For the END_PREFIX_MAPPING command*/
  static final int END_PREFIX_MAPPING     = 10 ;

  /** For convert the constant into string */
  static final String [] ContentHandlerInfo2String = {"START_ELEMENT", "END_ELEMENT", "START_DOCUMENT",
                                         "END_DOCUMENT", "SET_DOCUMENT_LOCATOR","SKIPPED_ENTITY",
                                         "IGNORABLE_WHITESPACE", "PROCESSING_INSTRUCTION", "CHARACTERS",
                                         "START_PREFIX_MAPPING", "END_PREFIX_MAPPING" } ;

}
