/**
 * $Id: OneInMultipleOut.java,v 1.3 2001/10/07 03:49:00 laurent Exp $
 *
 * Transmorpher
 * 
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package fr.fluxmedia.transmorpher.TProcessFactory ;

//Imported SAX Classes 

import org.xml.sax.ContentHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator ;
import org.xml.sax.SAXException;

public class OneInMultipleOut 
  implements ContentHandler {

  ContentHandler [] iListOfContent = null ;

  int iNbContentHandler = 0;

  public OneInMultipleOut (int p) {
    iListOfContent = new ContentHandler[p];
  }

  public final void addContentHandler(ContentHandler pContentHandler) {
     iListOfContent[ iNbContentHandler++] = pContentHandler ;
  }
  
  
  public final void startElement(String ns,String localName,String name, Attributes atts) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].startElement( ns, localName, name,  atts);
    }
  }

  public final void endElement(String ns,String localName,String name) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].endElement( ns, localName, name);
    }
  }

  public final void setDocumentLocator(Locator locator) {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].setDocumentLocator( locator);
    }
  }

  public final void startDocument() throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].startDocument();
    }
  }
  public final void endDocument() throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].endDocument();
    }
  }

  public final void skippedEntity(java.lang.String name) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].skippedEntity( name);
    }
  }

  public final void processingInstruction(java.lang.String target, java.lang.String data) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].processingInstruction(target, data);
    }
  }

  public final void ignorableWhitespace(char[] ch, int start, int length) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].ignorableWhitespace( ch,  start,  length);
    }
  }

  public final void characters(char[] ch, int start, int length) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].characters( ch,  start,  length);
    }
  }

  public final void startPrefixMapping(java.lang.String prefix, java.lang.String uri) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].startPrefixMapping( prefix,uri);
    }
  }

  public final void endPrefixMapping(java.lang.String prefix) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].endPrefixMapping( prefix);
    }
  }

} //end class
