/**
 * $Id: TApplyExternal.java,v 1.12 2001/12/20 12:11:28 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

 /** The instance  constructor
  
  @throws TransformerException
  @throws TransformerConfigurationException
  @throws SAXException
  @throws IOException
  
  */

package fr.fluxmedia.transmorpher.TProcessFactory;


// Imported transmorpher classes
import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.Parameters;

// Imported TraX classes

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXResult;

// Imported SAX classes

import org.xml.sax.SAXException;

// Imported Java classes

import java.io.IOException;
import java.util.Enumeration;

/**
  During the parse process an xsl file was generated to handle the define external.
  So, the external process, is only a transformer
*/
public final class TApplyExternal extends TTransformer{


  /** the empty constructor */
  /*public TApplyExternal (){}*/
    
  public TApplyExternal (String[] pIn, String[] pOut, Parameters pParam)
      throws TransformerException, TransformerConfigurationException,
             SAXException, IOException{
  
      super(pIn,pOut, pParam,(String)pParam.getParameter("file"));
      // This should be used by the factory for creating the class...
      type=(String)pParam.getParameter("type");
      //System.err.println("[TApplyExternal]constructor1 " + type
      //                    +","+(String)pParam.getParameter("file"));
      //this.iXSLFile=file;
  }

    // JE: This applies typically to "xslt".
    // Should be suppressed by the new organization of these processes
    public void bindParameters( Parameters p ){
	//p.printParameters();
	//iListOfParameters.printParameters();
	// First get the name of parameters that must be bound
	p.bindParameters( iListOfParameters );
	iXSLFile = (String)iListOfParameters.getParameter("file");
	try { initTransformer(); }
	catch (Exception e) { System.err.println("TTransformer generation: "+e); }
	// Then pass them to the transformer instance
	for( Enumeration e = iListOfParameters.getNames() ; e.hasMoreElements(); ){
	    String key = (String)e.nextElement();
	    //System.err.println("In TT: Set "+key+" to "+(String)iListOfParameters.getParameter(key));
	    getTransformer().setParameter(key,iListOfParameters.getParameter(key));
	} //end for
    }
    

    
  public String getFile(){
    return iXSLFile;
  }

     
} //end class
