/**
 * $Id: TApplyRuleSet.java,v 1.11 2001/12/20 12:11:28 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

 /** The instance  constructor
  
  @throws TransformerException
  @throws TransformerConfigurationException
  @throws SAXException
  @throws IOException
  
  */

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported JAXP classes

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXResult;

// Imported SAX classes

import org.xml.sax.SAXException;

// Imported Java classes

import java.io.IOException;
import java.util.Hashtable;

// Imported Transmorpher classes

import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Utils.StringParameters;

/**
  During the parse process an xsl file was generated to handle the define ruleset.
  So, the rule set process, is only a transformer
*/
public final class TApplyRuleSet extends TTransformer{

  String queryName = null;

  /** the strategy is either topdown or bottomup*/
  protected String strategy = "topdown";
    
  /** the ref  for the file of the transformer*/
  protected String ref = null;

  public TApplyRuleSet (String[] pIn, String[] pOut,
                        Parameters pParam,
                        StringParameters staticAttributes)
    throws TransformerException, TransformerConfigurationException,
           SAXException, IOException{

    super(pIn,pOut,pParam,(String)staticAttributes.getStringParameter("file"));
    strategy = (String) pParam.getParameter("strategy");
    ref = (String) pParam.getParameter("ref");
    //System.err.println("[TApplyRuleSet]constructor1 " + ref);
  }

  public String getRef(){
    return ref;
  }

  
  public void generatePort(){
  
    //Create the in and out port
    if(nameFather == null) {
      iListIn [0] = new XML_Port(nameIn[0],this,iTransformerHandler,0,XML_Port.IN);
      iListOut[0] = new XML_Port(nameOut[0],this,iTransformerHandler,0,XML_Port.OUT);
    } else {
      iListIn [0] = new XML_Port(nameFather+"-"+nameIn[0],this,iTransformerHandler,0,XML_Port.IN);
      iListOut[0] = new XML_Port(nameFather+"-"+nameOut[0],this,iTransformerHandler,0,XML_Port.OUT);
    } //end if
  } //end proc
    
}
