/**
 * $Id: TMain.java,v 1.12 2001/12/19 13:32:46 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/** define the structure for a transmorpher execution
*/


package fr.fluxmedia.transmorpher.TProcessFactory;

//import jaxp classes
import javax.xml.transform.TransformerException;

//import sax classes
import org.xml.sax.SAXException;

// import java classes
import java.io.IOException;
import java.util.Enumeration;

import fr.fluxmedia.transmorpher.Files.*;
import fr.fluxmedia.transmorpher.Utils.Parameters;

public class TMain extends TProcessComposite{
    
  public TMain(Parameters pParams) throws TransformerException,SAXException,IOException {
    super(new String[0],new String[0],pParams);
  }

  public void addProcess(TProcess process){
   
    if(process instanceof TApplyProcess) {
       this.addApplyProcess(process);
    } else {
      listOfProcessBasic.add(process);
    } //end if
   
   if (process instanceof TReader) this.addGenerator(process);
  
  }

    // I have trouble seeing the difference with what is in TProcessComposite
  public void bindPorts(TProcess process){
    process.generatePort() ;
   
   //System.out.println("debut for " + process);
    for(int i=0 ; i < process.getNameOut().length ; i++) {
      if(process.getNameOut(i).equals("_null_")) {
        this.addChannel(new TChannel("_null_",process,null));
	//      else if(process.getNameOut(i).equals("_stdout_")) {
      } else {
        listOfProcessOut.put(process.getNameOut(i),process);
        TProcess isSameIn = (TProcess)listOfProcessIn.get(process.getNameOut(i));
        if(isSameIn!=null){
          this.addChannel(new TChannel(process.getNameOut(i),process,isSameIn));
          listOfProcessIn.remove(process.getNameOut(i));
          listOfProcessOut.remove(process.getNameOut(i));
        }//end if
      } //end if
    }//end for
    //System.out.println("fin for");
  
    for(int i=0 ; i < process.getNameIn().length ; i++) {
	//if(process.getNameOut(i).equals("_stdin_")) {
	//} else {
	  //System.out.println(process.getNameIn(i).getCompositeName());
	  listOfProcessIn.put(process.getNameIn(i),process);
	  TProcess isSameOut =(TProcess)listOfProcessOut.get(process.getNameIn(i));
	  if(isSameOut!=null){
	      this.addChannel(new TChannel(process.getNameIn(i),isSameOut,process));
	      listOfProcessIn.remove(process.getNameIn(i));
	      listOfProcessOut.remove(process.getNameIn(i));
	  } //end if
	  //} // end if
        
    } //end for
    //System.out.println("fin");
}
}
